using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using iTextSharp.text;
using iTextSharp.text.pdf;

namespace sigplusnet_itextsharp_existingpdf
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void cmdSign_Click(object sender, EventArgs e)
        {
            sigPlusNET2.SetTabletState(0);
            sigPlusNET1.SetTabletState(1);
        }

        private void cmdClear_Click(object sender, EventArgs e)
        {
            sigPlusNET1.ClearTablet();
        }

        private void cmdSign2_Click(object sender, EventArgs e)
        {
            sigPlusNET1.SetTabletState(0);
            sigPlusNET2.SetTabletState(1);
        }

        private void cmdClear2_Click(object sender, EventArgs e)
        {
            sigPlusNET2.ClearTablet();
        }

        private void cmdPlaceSignatures_Click(object sender, EventArgs e)
        {
            if ((sigPlusNET1.NumberOfTabletPoints() == 0) || (sigPlusNET2.NumberOfTabletPoints() == 0))
            {
                //User must sign first!!
            }
            else
            {
                sigPlusNET1.SetTabletState(0); //turn off signature pad
                sigPlusNET2.SetTabletState(0);
                PdfReader reader = new PdfReader(Application.StartupPath + "\\TL462.pdf");
                PdfStamper stamper = new PdfStamper(reader, new System.IO.FileStream(Application.StartupPath + "\\test.pdf", System.IO.FileMode.Create));
                PdfContentByte overContent = stamper.GetOverContent(1);

                try
                {
                    // We add signature image to the document

                    sigPlusNET1.SetJustifyY(20);
                    sigPlusNET1.SetJustifyX(20);
                    sigPlusNET1.SetImageFileFormat(0); //0=bmp, 4=jpg, 6=tif

                    sigPlusNET2.SetJustifyY(20);
                    sigPlusNET2.SetJustifyX(20);
                    sigPlusNET2.SetImageFileFormat(0); //0=bmp, 4=jpg, 6=tif

                    int minX, maxX, minY, maxY, aX, aY, ratio, aIndex, bIndex, fixedY;

                    // First signature

                    minX = sigPlusNET1.GetPointXValue(0, 1);
                    maxX = sigPlusNET1.GetPointXValue(0, 1);
                    minY = sigPlusNET1.GetPointYValue(0, 1);
                    maxY = sigPlusNET1.GetPointYValue(0, 1);

                    for (aIndex = 0; aIndex < sigPlusNET1.GetNumberOfStrokes(); aIndex++)
                    {
                        for (bIndex = 0; bIndex < sigPlusNET1.GetNumPointsForStroke(aIndex); bIndex++)
                        {
                            aX = sigPlusNET1.GetPointXValue(aIndex, bIndex);
                            aY = sigPlusNET1.GetPointYValue(aIndex, bIndex);

                            if (aX < minX)
                            {
                                minX = aX;
                            }

                            if (aX > maxX)
                            {
                                maxX = aX;
                            }

                            if (aY < minY)
                            {
                                minY = aY;
                            }

                            if (aY > maxY)
                            {
                                maxY = aY;
                            }

                        }
                    }

                    ratio = ((maxX - minX) / (maxY - minY));
                    fixedY = 200;
                    sigPlusNET1.SetImagePenWidth((int)(fixedY * 0.1));
                    sigPlusNET1.SetJustifyMode(5);

                    sigPlusNET1.SetImageXSize((int)((ratio * fixedY) * 1.5));
                    sigPlusNET1.SetImageYSize((int)(fixedY * 1.5));
                    sigPlusNET1.SetAntiAliasLineScale(0.4f);
                    sigPlusNET1.SetAntiAliasSpotSize(0.25f);

                    System.Drawing.Image sigImage1 = sigPlusNET1.GetSigImage();

                    iTextSharp.text.Image image = iTextSharp.text.Image.GetInstance(sigImage1, System.Drawing.Imaging.ImageFormat.Gif);

                    image.Transparency = new int[] { 255, 255 };
                    image.SetAbsolutePosition(50, 400);
                    image.ScalePercent(30);

                    overContent.AddImage(image);

                    // Second signature

                    minX = sigPlusNET2.GetPointXValue(0, 1);
                    maxX = sigPlusNET2.GetPointXValue(0, 1);
                    minY = sigPlusNET2.GetPointYValue(0, 1);
                    maxY = sigPlusNET2.GetPointYValue(0, 1);

                    for (aIndex = 0; aIndex < sigPlusNET2.GetNumberOfStrokes(); aIndex++)
                    {
                        for (bIndex = 0; bIndex < sigPlusNET2.GetNumPointsForStroke(aIndex); bIndex++)
                        {
                            aX = sigPlusNET2.GetPointXValue(aIndex, bIndex);
                            aY = sigPlusNET2.GetPointYValue(aIndex, bIndex);

                            if (aX < minX)
                            {
                                minX = aX;
                            }

                            if (aX > maxX)
                            {
                                maxX = aX;
                            }

                            if (aY < minY)
                            {
                                minY = aY;
                            }

                            if (aY > maxY)
                            {
                                maxY = aY;
                            }

                        }
                    }

                    ratio = ((maxX - minX) / (maxY - minY));
                    fixedY = 200;
                    sigPlusNET2.SetImagePenWidth((int)(fixedY * 0.1));
                    sigPlusNET2.SetJustifyMode(5);

                    sigPlusNET2.SetImageXSize((int)((ratio * fixedY) * 1.5));
                    sigPlusNET2.SetImageYSize((int)(fixedY * 1.5));
                    sigPlusNET2.SetAntiAliasLineScale(0.4f);
                    sigPlusNET2.SetAntiAliasSpotSize(0.25f);

                    System.Drawing.Image sigImage2 = sigPlusNET2.GetSigImage();

                    iTextSharp.text.Image image2 = iTextSharp.text.Image.GetInstance(sigImage2, System.Drawing.Imaging.ImageFormat.Gif);

                    image2.Transparency = new int[] { 255, 255 };
                    image2.SetAbsolutePosition(50, 200);
                    image2.ScalePercent(30);

                    overContent.AddImage(image2);

                    stamper.Close();
                    reader.Close();

                }
                catch (DocumentException de)
                {
                    //Console.WriteLine(de.Message);
                }
                catch (IOException ioe)
                {
                    //Console.WriteLine(ioe.Message);
                }
            }
        }
    }
}