using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using iTextSharp.text;
using iTextSharp.text.pdf;

namespace sigplusnet_itextsharp_newpdf
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void cmdSign_Click(object sender, EventArgs e)
        {
            sigPlusNET1.SetTabletState(1);
        }

        private void cmdClear_Click(object sender, EventArgs e)
        {
            sigPlusNET1.ClearTablet();
        }

        private void cmdPlaceSignature_Click(object sender, EventArgs e)
        {
            if (sigPlusNET1.NumberOfTabletPoints() == 0)
            {
                //User must sign first!!
            }
            else
            {
                sigPlusNET1.SetTabletState(0); //turn off signature pad
                //continue with PDF creation and add signature image
                // step 1: creation of a document-object
                Document document = new Document();

                try
                {

                    // step 2:
                    // we create a writer that listens to the document
                    // and directs a PDF-stream to a file
                    PdfWriter writer = PdfWriter.GetInstance(document, new FileStream("SignatureTest.pdf", FileMode.Create));

                    // step 3: we open the document
                    document.Open();

                    // step 4: we add signature image to the document
                    document.Add(new Phrase("Sample text for signature demo"));

                    System.Drawing.Image sigimage;

                    sigPlusNET1.SetImageXSize(1000);
                    sigPlusNET1.SetImageYSize(300);
                    sigPlusNET1.SetJustifyY(10);
                    sigPlusNET1.SetJustifyX(10);
                    sigPlusNET1.SetJustifyMode(5);
                    sigPlusNET1.SetImagePenWidth(10);
                    sigPlusNET1.SetImageFileFormat(4); //0=bmp, 4=jpg, 6=tif
                    sigimage = sigPlusNET1.GetSigImage();

                    PdfContentByte cb = writer.DirectContent;
                    iTextSharp.text.Image image = iTextSharp.text.Image.GetInstance(sigimage, System.Drawing.Imaging.ImageFormat.Jpeg);
                    image.ScalePercent(20);
                    image.Transparency = new int[] { 255, 255 };
                    image.SetAbsolutePosition(100, 200);

                    cb.AddImage(image);

                }
                catch (DocumentException de)
                {
                    //Console.WriteLine(de.Message);
                }
                catch (IOException ioe)
                {
                    //Console.WriteLine(ioe.Message);
                }

                // step 5: we close the document
                document.Close();
            }
        }
    }
}