﻿Imports iTextSharp.text
Imports iTextSharp.text.pdf

Public Class Form1

    Private Sub cmdSign1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSign1.Click
        SigPlusNET2.SetTabletState(0)
        SigPlusNET1.SetTabletState(1)
    End Sub

    Private Sub cmdClear1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear1.Click
        SigPlusNET1.ClearTablet()
    End Sub

    Private Sub cmdSign2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSign2.Click
        SigPlusNET1.SetTabletState(0)
        SigPlusNET2.SetTabletState(1)
    End Sub

    Private Sub cmdClear2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClear2.Click
        SigPlusNET2.ClearTablet()
    End Sub

    Private Sub cmdPlaceSigs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPlaceSigs.Click
        If SigPlusNET1.NumberOfTabletPoints() = 0 Or SigPlusNET2.NumberOfTabletPoints() = 0 Then
            'User must sign first!!
        Else
            SigPlusNET1.SetTabletState(0)
            SigPlusNET2.SetTabletState(0)

            Dim reader As PdfReader = New PdfReader(Application.StartupPath & "\TL462.pdf")
            Dim stamper As PdfStamper = New PdfStamper(reader, New System.IO.FileStream(Application.StartupPath + "\test.pdf", System.IO.FileMode.Create))
            Dim overContent As PdfContentByte = stamper.GetOverContent(1)

            Try
                'We add signature image to the document

                SigPlusNET1.SetJustifyY(20)
                SigPlusNET1.SetJustifyX(20)
                SigPlusNET1.SetImageFileFormat(0) '0=bmp, 4=jpg, 6=tif

                SigPlusNET2.SetJustifyY(20)
                SigPlusNET2.SetJustifyX(20)
                SigPlusNET2.SetImageFileFormat(0) '0=bmp, 4=jpg, 6=tif

                Dim minX, maxX, minY, maxY, aX, aY, ratio, aIndex, bIndex, fixedY As Integer

                'First signature

                minX = SigPlusNET1.GetPointXValue(0, 1)
                maxX = SigPlusNET1.GetPointXValue(0, 1)
                minY = SigPlusNET1.GetPointYValue(0, 1)
                maxY = SigPlusNET1.GetPointYValue(0, 1)

                For aIndex = 0 To (SigPlusNET1.GetNumberOfStrokes() - 1)
                    For bIndex = 0 To (SigPlusNET1.GetNumPointsForStroke(aIndex) - 1)
                        aX = SigPlusNET1.GetPointXValue(aIndex, bIndex)
                        aY = SigPlusNET1.GetPointYValue(aIndex, bIndex)

                        If aX < minX Then
                            minX = aX
                        End If

                        If aX > maxX Then
                            maxX = aX
                        End If

                        If aY < minY Then
                            minY = aY
                        End If

                        If aY > maxY Then
                            maxY = aY
                        End If
                    Next
                Next

                ratio = ((maxX - minX) / (maxY - minY))
                fixedY = 200
                SigPlusNET1.SetImagePenWidth(Int(fixedY * 0.1))
                SigPlusNET1.SetJustifyMode(5)

                SigPlusNET1.SetImageXSize(Int((ratio * fixedY) * 1.5))
                SigPlusNET1.SetImageYSize(Int(fixedY * 1.5))
                SigPlusNET1.SetAntiAliasLineScale(0.4F)
                SigPlusNET1.SetAntiAliasSpotSize(0.25F)

                Dim sigImage1 As System.Drawing.Image = SigPlusNET1.GetSigImage()

                Dim image As iTextSharp.text.Image = iTextSharp.text.Image.GetInstance(sigImage1, System.Drawing.Imaging.ImageFormat.Gif)

                image.Transparency = New Integer() {255, 255}
                image.SetAbsolutePosition(50, 400)
                image.ScalePercent(30)

                overContent.AddImage(image)

                'Second signature

                minX = SigPlusNET2.GetPointXValue(0, 1)
                maxX = SigPlusNET2.GetPointXValue(0, 1)
                minY = SigPlusNET2.GetPointYValue(0, 1)
                maxY = SigPlusNET2.GetPointYValue(0, 1)

                For aIndex = 0 To (SigPlusNET2.GetNumberOfStrokes() - 1)
                    For bIndex = 0 To (SigPlusNET2.GetNumPointsForStroke(aIndex) - 1)
                        aX = SigPlusNET2.GetPointXValue(aIndex, bIndex)
                        aY = SigPlusNET2.GetPointYValue(aIndex, bIndex)

                        If aX < minX Then
                            minX = aX
                        End If

                        If aX > maxX Then
                            maxX = aX
                        End If

                        If aY < minY Then
                            minY = aY
                        End If

                        If aY > maxY Then
                            maxY = aY
                        End If
                    Next
                Next

                ratio = ((maxX - minX) / (maxY - minY))
                fixedY = 200
                SigPlusNET2.SetImagePenWidth(Int(fixedY * 0.1))
                SigPlusNET2.SetJustifyMode(5)

                SigPlusNET2.SetImageXSize(Int((ratio * fixedY) * 1.5))
                SigPlusNET2.SetImageYSize(Int(fixedY * 1.5))
                SigPlusNET2.SetAntiAliasLineScale(0.4F)
                SigPlusNET2.SetAntiAliasSpotSize(0.25F)

                Dim sigImage2 As System.Drawing.Image = SigPlusNET2.GetSigImage()

                Dim image2 As iTextSharp.text.Image = iTextSharp.text.Image.GetInstance(sigImage2, System.Drawing.Imaging.ImageFormat.Gif)

                image2.Transparency = New Integer() {255, 255}
                image2.SetAbsolutePosition(50, 200)
                image2.ScalePercent(30)

                overContent.AddImage(image2)

                stamper.Close()
                reader.Close()
            Catch ex As Exception

            End Try
        End If
    End Sub
End Class
